package FEJDGui;
import java.awt.event.*;
import javax.swing.*;
import java.awt.*;

/** Frame which is displayed at the beginning of the program */
public class AboutBox extends JDialog implements ActionListener
{
	/** The labels of the box */
	private JLabel l1,l4,l6;

	/** Constructs a new AboutBox */
	public AboutBox(JFrame frame)
	{
		super(frame, false);
		setUndecorated(true);
		setResizable(false);

		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		int winwidth = 550;
		int winheight = 375;

		setBounds((dim.width-winwidth)/2, (dim.height-winheight)/2, winwidth, winheight);
		Panel panel = new Panel();
		panel.setBackground(new Color(220,220,255));

		ImageIcon imgIco = new ImageIcon(this.getClass().getClassLoader().getResource("gif/FEJD.jpeg"));

		JLabel imgLbl = new JLabel(imgIco);
		imgLbl.setAlignmentX(0.5F);
		l1 = new JLabel(Display.frame.MB.getString("ProgrammedBy"));
		l1.setAlignmentX(0.5F);
		l1.setFont(new Font("Serif", Font.PLAIN, 14));
		JLabel l2 = new JLabel("Aurlien Boffy & Jrmie Simon");
		l2.setAlignmentX(0.5F);
		l2.setFont(new Font("Serif", Font.BOLD, 16));
		JLabel l21 = new JLabel("boffya@eleves.enpc.fr - jeremie.simon@free.fr");
		l21.setAlignmentX(0.5F);
		l21.setFont(new Font("Serif", Font.ITALIC, 14));
		JLabel l3 = new JLabel("(Ecole Nationale des Ponts et Chausses - Paris)");
		l3.setAlignmentX(0.5F);
		l3.setFont(new Font("Serif", Font.PLAIN, 14));
		l4 = new JLabel(Display.frame.MB.getString("Supervision"));
		l4.setAlignmentX(0.5F);
		l4.setFont(new Font("Serif", Font.PLAIN, 14));
		JLabel l5 = new JLabel("Michael Jung & Kshitij Kulshreshtha");
		l5.setAlignmentX(0.5F);
		l5.setFont(new Font("Serif", Font.BOLD, 16));
		JLabel l51 = new JLabel("mjung@math.tu-dresden.de - kshitij@math.tu-dresden.de");
		l51.setAlignmentX(0.5F);
		l51.setFont(new Font("Serif", Font.ITALIC, 14));
		l6 = new JLabel("(" + Display.frame.MB.getString("ScientificComputing") + ", Technische Universitt Dresden)");
		l6.setAlignmentX(0.5F);
		l6.setFont(new Font("Serif", Font.PLAIN, 14));

		JButton button = new JButton("OK");
		button.setAlignmentX(0.5F);
		button.addActionListener(this);

		Box b = Box.createVerticalBox();
		b.add(Box.createVerticalStrut(10));
		b.add(imgLbl);
		b.add(Box.createVerticalStrut(25));
		b.add(l1);
		b.add(Box.createVerticalStrut(10));
		b.add(l2);
		b.add(Box.createVerticalStrut(5));
		b.add(l21);
		b.add(Box.createVerticalStrut(5));
		b.add(l3);
		b.add(Box.createVerticalStrut(20));
		b.add(l4);
		b.add(Box.createVerticalStrut(10));
		b.add(l5);
		b.add(Box.createVerticalStrut(5));
		b.add(l51);
		b.add(Box.createVerticalStrut(5));
		b.add(l6);
		b.add(Box.createVerticalStrut(30));
		b.add(button);
		b.add(Box.createVerticalStrut(5));
		panel.add(b);

		Container contentPane = getContentPane();
		contentPane.add(panel);
	}

	/** Closes the box */
	public void actionPerformed(ActionEvent e)
	{
		hide();
	}

	/** Updates the labels upon lanquage change */
	public void update()
	{
		l1.setText(Display.frame.MB.getString("ProgrammedBy"));
		l4.setText(Display.frame.MB.getString("Supervision"));
		l6.setText("(" + Display.frame.MB.getString("ScientificComputing") + ", Technische Universitt Dresden)");
	}
}
