package FEJDGui;

import javax.swing.*;

public interface OurMenuBar
{

	/** Initiates the default language */
	public void initLocale();
	/** Returns the string of the resource bundle */
	public String getString(String s);
	/** Modifies the labels upon language change */
	public void updateAll(JMenuItem source);
	/** Updates the labels when the user changes the language */
	public void update(JMenuItem source);
	/** Returns true if the users has chosen to display the Cholesky-Factorization */
	public boolean isDisplDecomp();
	/** Returns true if the display help menu item is ticked */
	public boolean isDisplayingDoc();
	/** Returns true if the quadratic functions are selected */
	public boolean isQuadraticFctSelected();
	/** Returns true if the linear functions are selected */
	public boolean isLinearFctSelected();
	/** Sets the state of the save Jpeg menu */
	public void setJpegEnabled(boolean state);
	/** Sets the save solution of the Jpeg menu */
	public void setSolutionEnabled(boolean state);
	/** Sets the state of the refinement menu */
	public void setRefinementEnabled(boolean state);
	/** Sets the state of the renumbering menu */
	public void setRenumEnabled(boolean state);
	/** Returns true if the auto-renumbering selected */
	public boolean isAutoRenumSelected();
	/** Returns true if the menu for creatig new files after a refinement is selected */
	public boolean isNewFileRefineSelected();
	/** Sets the state of the menu for creating new files after a renumbering */
	public void setNewFileRenumEnabled(boolean state);

}
